!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine DensityCloud
!
!   * Developer: Kitamori Taichi
!   * Version: $Id: densitycloud_falltest2.f90,v 1.2 2011-12-15 03:42:15 yamasita Exp $ 
!   * Tag Name: $Name: arare4-20120511 $
!   * Change History: 
!
!== Overview 
!
! ̩٤λȯŸ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!   * եå򤤤Ƥ
!   * ̩׻ѥƥȥץ.
!     * ήȻ, Ǵ, ήۤ˥.
!     * γȾ¤ϱ̩٤Τߤ˰¸ΤȤ. 
!     * Cunningham Ϲθʤ. 
!     * Stokes §ηʬϱγȾ¤Τߤ˰¸ΤȤ. 
!  
!== Future Plans
!
                                                                 !=end
subroutine DensityCloud(      &
  & xz_DensCloudNs,                 & !(in) ̩
  & DelTimeShort,                   & !(in) ֥ƥå
  & xz_DensCloudWorkAs)               !(out) ̩(̩٤Ĵ)

                                                                 !=begin  
  !== Dependancy
  use dc_trace, only: BeginSub, EndSub, DbgMessage
  use gridset,  only: DimXMin, DimXMax, DimZMin, DimZMax
  use average,  only: xr_avr_xz
  use differentiate_center4, only: xz_dz_xr
  use basicset, only: Grav, PressSfc, GasRDry, CpDry, &
               &      xz_ExnerBasicZ, xz_PotTempBasicZ, &
               &      xz_DensBasicZ
  use cloudset, only: DensIce, &        ! ʪ̩
    &                 NumAerosol, &     ! ̤ζŷ˿̩
    &                 RadiAerosol       ! ŷȾ

  use StoreDensCloud, only: StoreDensCloudFall
                                                                 !=end
  !== ۤηػ
  implicit none
                                                                 !=begin
  !== Input
  real(8), intent(in)  :: DelTimeShort  ! ॹƥå [s]
  real(8), intent(in)  :: xz_DensCloudNs(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̩ [kg/m^3]
  !== Output
  real(8), intent(out)  :: xz_DensCloudWorkAs(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! ̩(̩Ĵ) [kg/m^3]

                                                                 !=end  
  !== Work

  real(8)  :: xz_TendDensCloudNl(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! Ĺ֥ƥåפɾ [kg/m^3 s]
  real(8)  :: xz_RadiCloudNs(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γȾ [m]
  real(8)  :: xz_FallDensCloud(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γˤ̩٤λѲΨ [kg/m^3 s]
  real(8)  :: xz_VelZTerm(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γνü®
  real(8)  :: xz_VisCoffCO2(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! CO2 Ǵ
  real(8)  :: xz_MeanFreePath(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! CO2 ʿѼͳ
  real(8)  :: xz_KnudsenNum(DimXMin:DimXMax, DimZMin:DimZMax)
                                        ! γФ Knudsen 
  real, parameter :: Pi = 3.1415926535897932385d0
                                        ! ߼Ψ
  real, parameter :: BoltzmannConst = 1.38065d-23
                                        ! ܥĥޥ
  real, parameter :: CO2Diam = 3.30d-10
                                        ! CO2 ʬҤ kinetic diameter
  real, parameter :: SutherlandConst = 2.40d2
                                        ! CO2 ʬҤΥ
  real, parameter :: VisCoffRef = 1.47d-5
                                        ! Ǵλ
  real, parameter :: TempRef = 2.93d2
                                        ! ǴλȲ

  call BeginSub("DensityCloud", &
       &        fmt="%c",              &
       &        c1="Time integration of density of cloud.")
  
!  write(*,*) xz_DensCloudNl(1,:)

  !=== Ǵη׻
  xz_VisCoffCO2 = &
    & VisCoffRef * (TempRef + SutherlandConst) &
    & / ( xz_PotTempBasicZ * xz_ExnerBasicZ  &
    &     + SutherlandConst ) &
    & * ( xz_PotTempBasicZ * xz_ExnerBasicZ  &
    &     / TempRef )**1.5d0

  !=== ʿѼͳη׻
!  xz_MeanFreePath = &
!    & BoltzMannConst * &
!    & xz_PotTempBasicZ * xz_ExnerBasicZ  &
!    & / ( 2.0**0.5d0 * Pi * (CO2Diam)**2.0d0 * PressSfc &
!    &    * (xz_ExnerBasicZ)**(CpDry/GasRDry) )
  xz_MeanFreePath = 1.0d-5 ! ƥ

  !=== γȾ¤η׻
!  xz_RadiCloudNs =   &
!    & (  &
!    &      3.0d0 * xz_DensCloudNs &
!    &      / (4.0d0 * Pi * DensIce * NumAerosol * xz_DensBasicZ) &
!    &      + RadiAerosol**3.0d0  &
!    &   )**(1.0d0 / 3.0d0)
  xz_RadiCloudNs = &
    & ( 3.0d-11 * xz_DensCloudNs + RadiAerosol**3.0d0 )**(1.0d0 / 3.0d0)

  !=== Knudsen η׻
  xz_KnudsenNum = &
    & xz_MeanFreePath / xz_RadiCloudNs

  !=== ü®٤η׻
!  xz_VelZTerm = &
!    & ( 1.0d0 + 4.0d0 * xz_KnudsenNum / 3.0d0 ) &
!    & * 2.0d0 * xz_RadiCloudNs * xz_RadiCloudNs * Grav * DensIce  &
!    & / (9.0d0 * xz_VisCoffCO2)
  xz_VelZTerm = 2.0d8 * xz_RadiCloudNs**2.0d0

  !=== η׻. 4 濴ʬѤƷ׻
  xz_FallDensCloud = &
    & xz_dz_xr(xr_avr_xz(xz_VelZTerm * xz_DensCloudNs))

  call StoreDensCloudFall( xz_FallDensCloud )

  xz_DensCloudWorkAs = xz_DensCloudNs  &
    & + DelTimeShort * xz_FallDensCloud

!  !=== 
!  call boundary(xz_BC, xz_DensCloud_out)
!
  call EndSub("DensityCloud")
  
end subroutine DensityCloud
